import { Model } from '../model/model';
import { DatastoreAdapter } from './adapters/adapter';
import { FilterMethod } from './interfaces/filter.type';
import { IPaginationData } from './interfaces/pagination.type';
export declare class Datastore<T extends Model<T>> {
    name: string;
    adapter: DatastoreAdapter<T>;
    constructor(name: string, adapter: DatastoreAdapter<T>);
    get(id: string): Promise<T | null>;
    getItems(options?: {
        filter?: FilterMethod<T>;
        pagination?: IPaginationData;
    }): Promise<T[]>;
    push(item: T): Promise<T>;
    remove(item: T | string): Promise<T | null>;
}
