import { Datastore } from '../datastore/datastore';
import { IModelMetadata, IFullfilledModelMetadata } from './model.metadata';
export declare class Model<T extends Model<T>> {
    meta: IModelMetadata;
    private store;
    constructor(store: Datastore<T>);
    hasMetadata(): this is {
        meta: IFullfilledModelMetadata;
    };
    save(): Promise<this>;
    delete(): Promise<void>;
}
