"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class DeleteOperation {
    constructor(store, id) {
        this._store = store;
        this._id = id;
    }
    item(item) {
        if (item.meta) {
            this._id = item.meta.id;
            return this;
        }
        else {
            throw Error('Object\'s meta field is null');
        }
    }
    id(id) {
        this._id = id;
        return this;
    }
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this._id == null) {
                throw new Error('Invalid parameters for DeleteOperation.');
            }
            return yield this._store.adapter.remove(this._id);
        });
    }
}
exports.DeleteOperation = DeleteOperation;
//# sourceMappingURL=delete.operation.js.map