"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const metadata_utils_1 = require("../datastore/metadata.utils");
class PushOperation {
    constructor(store) {
        this._store = store;
    }
    item(value) {
        this._toAdd = value;
        return this;
    }
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this._toAdd) {
                this._toAdd.meta = metadata_utils_1.MetadataUtils.getNewMetadata();
                return yield this._store.adapter.put(this._toAdd);
            }
            else {
                throw Error('Nothing is being pushed.');
            }
        });
    }
}
exports.PushOperation = PushOperation;
//# sourceMappingURL=push.operation.js.map